<script setup lang="ts">
import { reactive, onMounted, toRaw, ref } from 'vue';
import { useRoute, useRouter } from 'vue-router';
import { PageContainer } from 'antdv-pro-layout';
import { ProModal } from 'antdv-pro-modal';
import { Form, message, Modal } from 'ant-design-vue/es';
import { SizeType } from 'ant-design-vue/es/config-provider';
import { MenuInfo } from 'ant-design-vue/es/menu/src/interface';
import { ColumnsType } from 'ant-design-vue/es/table';
import { parseDateToStr } from '@/utils/date-utils';
import { MENU_PATH_INLINE } from '@/constants/menu-constants';
import { RESULT_CODE_SUCCESS } from '@/constants/result-constants';
import useI18n from '@/hooks/useI18n';
import useNeInfoStore from '@/store/modules/neinfo';
import {
  addTraceTask,
  delTraceTask,
  getTraceTask,
  listTraceTask,
  updateTraceTask,
} from '@/api/trace/task';
import useDictStore from '@/store/modules/dict';
import { regExpIPv4, regExpPort } from '@/utils/regular-utils';
import dayjs, { Dayjs } from 'dayjs';
import { parseObjHumpToLine } from '@/utils/parse-utils';
const neInfoStore = useNeInfoStore();
const { getDict } = useDictStore();
const { t } = useI18n();
const router = useRouter();
const route = useRoute();

/**字典数据 */
let dict: {
  /**跟踪类型 */
  traceType: DictType[];
} = reactive({
  traceType: [],
});

/**网元类型_多neId */
let neCascaderOptions = ref<Record<string, any>[]>([]);

/**查询参数 */
let queryParams = reactive({
  /**网元类型 */
  neType: '',
  /**记录时间 */
  startTime: '',
  endTime: '',
  /**排序字段 */
  sortField: 'start_time',
  /**排序方式 */
  sortOrder: 'asc',
  /**当前页数 */
  pageNum: 1,
  /**每页条数 */
  pageSize: 20,
});

/**查询参数重置 */
function fnQueryReset() {
  queryParams = Object.assign(queryParams, {
    neType: '',
    startTime: '',
    endTime: '',
    sortField: 'start_time',
    sortOrder: 'asc',
    pageNum: 1,
    pageSize: 20,
  });
  tablePagination.current = 1;
  tablePagination.pageSize = 20;
  fnGetList();
}

/**表格状态类型 */
type TabeStateType = {
  /**加载等待 */
  loading: boolean;
  /**紧凑型 */
  size: SizeType;
  /**搜索栏 */
  seached: boolean;
  /**记录数据 */
  data: object[];
  /**勾选记录 */
  selectedRowKeys: (string | number)[];
};

/**表格状态 */
let tableState: TabeStateType = reactive({
  loading: false,
  size: 'middle',
  seached: true,
  data: [],
  selectedRowKeys: [],
});

/**表格字段列 */
let tableColumns: ColumnsType = [
  {
    title: t('views.ne.common.neType'),
    dataIndex: 'neType',
    align: 'left',
    sorter: {
      compare: (a, b) => 1,
      multiple: 1,
    },
  },
  {
    title: t('views.ne.common.neId'),
    dataIndex: 'neId',
    align: 'left',
  },
  {
    title: t('views.traceManage.task.traceId'),
    dataIndex: 'traceId',
    align: 'left',
  },
  {
    title: t('views.traceManage.task.trackType'),
    dataIndex: 'traceType',
    key: 'traceType',
    align: 'left',
  },
  {
    title: t('views.traceManage.task.startTime'),
    dataIndex: 'startTime',
    align: 'left',
    customRender(opt) {
      if (!opt.value) return '';
      return parseDateToStr(opt.value);
    },
    sorter: true,
  },
  {
    title: t('views.traceManage.task.endTime'),
    dataIndex: 'endTime',
    align: 'left',
    customRender(opt) {
      if (!opt.value) return '';
      return parseDateToStr(opt.value);
    },
  },
  {
    title: t('common.operate'),
    key: 'id',
    align: 'left',
  },
];

/**表格分页器参数 */
let tablePagination = reactive({
  /**当前页数 */
  current: 1,
  /**每页条数 */
  pageSize: 20,
  /**默认的每页条数 */
  defaultPageSize: 20,
  /**指定每页可以显示多少条 */
  pageSizeOptions: ['10', '20', '50', '100'],
  /**只有一页时是否隐藏分页器 */
  hideOnSinglePage: false,
  /**是否可以快速跳转至某页 */
  showQuickJumper: true,
  /**是否可以改变 pageSize */
  showSizeChanger: true,
  /**数据总数 */
  total: 0,
  showTotal: (total: number) => t('common.tablePaginationTotal', { total }),
  onChange: (page: number, pageSize: number) => {
    tablePagination.current = page;
    tablePagination.pageSize = pageSize;
    queryParams.pageNum = page;
    queryParams.pageSize = pageSize;
    fnGetList();
  },
});

/**表格紧凑型变更操作 */
function fnTableSize({ key }: MenuInfo) {
  tableState.size = key as SizeType;
}

/**表格多选 */
function fnTableSelectedRowKeys(keys: (string | number)[]) {
  tableState.selectedRowKeys = keys;
}

/**表格分页、排序、筛选变化时触发操作, 排序方式，取值为 ascend descend */
function fnTableChange(pagination: any, filters: any, sorter: any, extra: any) {
  const { field, order } = sorter;
  if (order) {
    queryParams.sortField = parseObjHumpToLine(field);
    queryParams.sortOrder = order.replace('end', '');
  } else {
    queryParams.sortOrder = 'asc';
  }
  fnGetList(1);
}

/**
 * 记录删除
 * @param id  编号
 */
function fnRecordDelete(id: string) {
  if (!id || modalState.confirmLoading) return;
  let msg = t('views.traceManage.task.delTaskTip', { id: id });
  if (id === '0') {
    const mun = `...${tableState.selectedRowKeys.length}`;
    msg = `${t('views.traceManage.task.delTaskTip', { id: mun })} `;
    id = tableState.selectedRowKeys.join(',');
  }

  Modal.confirm({
    title: t('common.tipTitle'),
    content: msg,
    onOk() {
      modalState.confirmLoading = true;
      const hide = message.loading(t('common.loading'), 0);
      delTraceTask(id)
        .then(res => {
          if (res.code === RESULT_CODE_SUCCESS) {
            message.success(t('common.operateOk'), 3);
            fnGetList();
          } else {
            message.error({
              content: `${res.msg}`,
              duration: 3,
            });
          }
        })
        .finally(() => {
          hide();
          modalState.confirmLoading = false;
        });
    },
  });
}

/**查询信息列表, pageNum初始页数 */
function fnGetList(pageNum?: number) {
  if (tableState.loading) return;
  tableState.loading = true;
  if (pageNum) {
    queryParams.pageNum = pageNum;
  }
  listTraceTask(toRaw(queryParams)).then(res => {
    if (res.code === RESULT_CODE_SUCCESS && Array.isArray(res.rows)) {
      // 取消勾选
      if (tableState.selectedRowKeys.length > 0) {
        tableState.selectedRowKeys = [];
      }
      tablePagination.total = res.total;
      tableState.data = res.rows;
      if (
        tablePagination.total <=
          (queryParams.pageNum - 1) * tablePagination.pageSize &&
        queryParams.pageNum !== 1
      ) {
        tableState.loading = false;
        fnGetList(queryParams.pageNum - 1);
      }
    }
    tableState.loading = false;
  });
}

/**对话框对象信息状态类型 */
type ModalStateType = {
  /**新增框或修改框是否显示 */
  openByEdit: boolean;
  /**标题 */
  title: string;
  /**网元类型设备对象 */
  neType: string[];
  /**网元类型设备对象接口 */
  neTypeInterface: Record<string, any>[];
  /**网元类型设备对象接口选择 */
  neTypeInterfaceSelect: string[];
  /**任务开始结束时间 */
  timeRangePicker: [string, string];
  /**表单数据 */
  from: {
    id?: string;
    neType: string;
    neId: string;
    /**1-Interface,2-Device,3-User */
    traceType: string;
    startTime?: number;
    endTime?: number;
    remark?: string;
    /**1接口跟踪 */
    interfaces?: string;
    /**2设备跟踪 */
    srcIp?: string;
    dstIp?: string;
    signalPort?: number;
    /**3用户跟踪 */
    imsi?: string;
    msisdn?: string;
  };
  /**确定按钮 loading */
  confirmLoading: boolean;
};

/**对话框对象信息状态 */
let modalState: ModalStateType = reactive({
  openByView: false,
  openByEdit: false,
  title: '',
  neType: [],
  neTypeInterface: [],
  neTypeInterfaceSelect: [],
  timeRangePicker: ['', ''],
  from: {
    id: '',
    neType: '',
    neId: '',
    traceId: '',
    traceType: '3',
    startTime: undefined,
    endTime: undefined,
    remark: '',
    /**1接口跟踪 */
    interfaces: '',
    /**2设备跟踪 */
    srcIp: '',
    dstIp: '',
    signalPort: undefined,
    /**3用户跟踪 */
    imsi: '',
    msisdn: '',
  },
  confirmLoading: false,
});

/**对话框内表单属性和校验规则 */
const modalStateFrom = Form.useForm(
  modalState.from,
  reactive({
    traceType: [
      {
        required: true,
        message: t('views.traceManage.task.trackTypePlease'),
      },
    ],
    neId: [
      {
        required: true,
        message: t('views.ne.common.neTypePlease'),
      },
    ],
    endTime: [
      {
        required: true,
        message: t('views.traceManage.task.rangePickerPlease'),
      },
    ],
    // 用户跟踪
    imsi: [
      {
        required: true,
        message: t('views.traceManage.task.imsiPlease'),
      },
    ],
    msisdn: [
      {
        required: false,
        message: t('views.traceManage.task.msisdnPlease'),
      },
    ],
    // 接口跟踪
    interfaces: [
      {
        required: true,
        message: t('views.traceManage.task.interfacesPlease'),
      },
    ],
    // 数据跟踪
    srcIp: [
      {
        required: true,
        pattern: regExpIPv4,
        message: t('views.traceManage.task.srcIpPlease'),
      },
    ],
    dstIp: [
      {
        required: true,
        pattern: regExpIPv4,
        message: t('views.traceManage.task.dstIpPlease'),
      },
    ],
    signalPort: [
      {
        required: false,
        pattern: regExpPort,
        message: t('views.traceManage.task.signalPortPlease'),
      },
    ],
  })
);

/**网元类型选择对应修改 */
function fnNeChange(_: any, item: any) {
  modalState.from.neType = item[1].neType;
  modalState.from.neId = item[1].neId;
  // 网元信令接口可选列表
  modalState.from.interfaces = '';
  modalState.neTypeInterfaceSelect = [];
  fnSelectInterfaceInit(item[1].neType);
}

/**跟踪类型选择对应修改 */
function fnTraceTypeChange(v: any, _: any) {
  // 网元信令接口可选列表
  if (v === '1' && modalState.from.neType) {
    modalState.from.interfaces = '';
    modalState.neTypeInterfaceSelect = [];
    fnSelectInterfaceInit(modalState.from.neType);
  }
}

/**开始结束时间选择对应修改 */
function fnRangePickerChange(item: any, _: any) {
  modalState.from.startTime = +item[0];
  modalState.from.endTime = +item[1];
}
function fnRangePickerDisabledDate(current: Dayjs) {
  return current && current < dayjs().subtract(1, 'day').endOf('day');
}

/**信令接口选择对应修改 */
function fnSelectInterface(s: any, _: any) {
  modalState.from.interfaces = s.join(',');
}

/**信令接口选择初始 */
function fnSelectInterfaceInit(neType: string) {
  const interfaces = neInfoStore.traceInterfaceList;
  modalState.neTypeInterface = interfaces
    .filter(i => i.neType === neType)
    .map(i => {
      return {
        value: i.interface,
        label: i.interface,
      };
    });
}

/**
 * 对话框弹出显示为 新增或者修改
 * @param noticeId 网元id, 不传为新增
 */
function fnModalOpenByEdit(id?: string) {
  if (!id) {
    fnModalCancel();
    modalState.title = t('views.traceManage.task.addTask');
    modalState.openByEdit = true;
  } else {
    if (modalState.confirmLoading) return;
    const hide = message.loading(t('common.loading'), 0);
    modalState.confirmLoading = true;
    getTraceTask(id).then(res => {
      modalState.confirmLoading = false;
      hide();
      if (res.code === RESULT_CODE_SUCCESS && res.data) {
        modalState.neType = [res.data.neType, res.data.neId];
        modalState.timeRangePicker = [res.data.startTime, res.data.endTime];
        modalState.from = Object.assign(modalState.from, res.data);
        // 接口
        if (res.data.traceType === 'Interface') {
          if (
            res.data.interfaces.length > 4 &&
            res.data.interfaces.includes('[')
          ) {
            modalState.neTypeInterfaceSelect = JSON.parse(res.data.interfaces);
          }
          fnSelectInterfaceInit(res.data.neType);
        }
        modalState.title = t('views.traceManage.task.editTask');
        modalState.openByEdit = true;
      } else {
        message.error(t('views.traceManage.task.errorTaskInfo'), 3);
      }
    });
  }
}

/**
 * 对话框弹出确认执行函数
 * 进行表达规则校验
 */
function fnModalOk() {
  const from = toRaw(modalState.from);
  let valids = ['traceType', 'neId', 'endTime'];
  if (from.traceType === '1') {
    valids = valids.concat(['interfaces']);
  }
  if (from.traceType === '2') {
    valids = valids.concat(['srcIp', 'dstIp', 'signalPort']);
  }
  if (from.traceType === '3') {
    valids = valids.concat(['imsi', 'msisdn']);
  }

  modalStateFrom
    .validate(valids)
    .then(e => {
      modalState.confirmLoading = true;
      const traceTask = from.id ? updateTraceTask(from) : addTraceTask(from);
      const hide = message.loading(t('common.loading'), 0);
      traceTask
        .then(res => {
          if (res.code === RESULT_CODE_SUCCESS) {
            message.success({
              content: t('common.msgSuccess', { msg: modalState.title }),
              duration: 3,
            });
            fnModalCancel();
          } else {
            message.error({
              content: `${res.msg}`,
              duration: 3,
            });
          }
        })
        .finally(() => {
          hide();
          modalState.confirmLoading = false;
          fnGetList(1);
        });
    })
    .catch(e => {
      message.error(t('common.errorFields', { num: e.errorFields.length }), 3);
    });
}

/**
 * 对话框弹出关闭执行函数
 * 进行表达规则校验
 */
function fnModalCancel() {
  modalState.openByEdit = false;
  modalState.confirmLoading = false;
  modalStateFrom.resetFields();
  modalState.timeRangePicker = ['', ''];
  modalState.neTypeInterfaceSelect = [];
  modalState.neType = [];
  modalState.neTypeInterface = [];
}

/**跳转PCAP文件详情页面 */
function fnRecordPCAPView(row: Record<string, any>) {
  router.push({
    path: `${route.path}${MENU_PATH_INLINE}/analyze`,
    query: {
      traceId: row.traceId,
    },
  });
}

onMounted(() => {
  // 初始字典数据
  Promise.allSettled([getDict('trace_type')]).then(resArr => {
    if (resArr[0].status === 'fulfilled') {
      dict.traceType = resArr[0].value;
    }
  });

  // 获取网元网元列表
  useNeInfoStore()
    .fnNelist()
    .then(res => {
      if (res.code === RESULT_CODE_SUCCESS && Array.isArray(res.data)) {
        if (res.data.length > 0) {
          // 过滤不可用的网元
          neCascaderOptions.value = neInfoStore.getNeSelectOtions.filter(
            (item: any) => {
              return ['UDM'].includes(item.value);
            }
          );
          if (neCascaderOptions.value.length === 0) {
            message.warning({
              content: t('common.noData'),
              duration: 2,
            });
            return;
          }
        }
      } else {
        message.warning({
          content: t('common.noData'),
          duration: 2,
        });
      }
    })
    .finally(() => {
      // 获取跟踪接口列表
      neInfoStore.fnNeTraceInterface();
      // 获取列表数据
      fnGetList();
    });
});
</script>

<template>
  <PageContainer>
    <a-card
      v-show="tableState.seached"
      :bordered="false"
      :body-style="{ marginBottom: '24px', paddingBottom: 0 }"
    >
      <!-- 表格搜索栏 -->
      <a-form :model="queryParams" name="queryParams" layout="horizontal">
        <a-row :gutter="16">
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item :label="t('views.ne.common.neType')" name="neType ">
              <a-auto-complete
                v-model:value="queryParams.neType"
                :options="neCascaderOptions"
                allow-clear
                :placeholder="t('views.ne.common.neTypePlease')"
              />
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item
              :label="t('views.traceManage.task.startTime')"
              name="startTime"
            >
              <a-date-picker
                show-time
                v-model:value="queryParams.startTime"
                format="YYYY-MM-DD HH:mm:ss"
                value-format="x"
                :placeholder="t('views.traceManage.task.startTime')"
                style="width: 100%"
              />
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item
              :label="t('views.traceManage.task.endTime')"
              name="endTime"
            >
              <a-date-picker
                show-time
                v-model:value="queryParams.endTime"
                format="YYYY-MM-DD HH:mm:ss"
                value-format="x"
                :placeholder="t('views.traceManage.task.endTime')"
                style="width: 100%"
              />
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item>
              <a-space :size="8">
                <a-button type="primary" @click.prevent="fnGetList(1)">
                  <template #icon><SearchOutlined /></template>
                  {{ t('common.search') }}
                </a-button>
                <a-button type="default" @click.prevent="fnQueryReset">
                  <template #icon><ClearOutlined /></template>
                  {{ t('common.reset') }}
                </a-button>
              </a-space>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
    </a-card>

    <a-card :bordered="false" :body-style="{ padding: '0px' }">
      <!-- 插槽-卡片左侧侧 -->
      <template #title>
        <a-space :size="8" align="center">
          <a-button type="primary" @click.prevent="fnModalOpenByEdit()">
            <template #icon><PlusOutlined /></template>
            {{ t('common.addText') }}
          </a-button>

          <a-button
            type="default"
            danger
            :disabled="tableState.selectedRowKeys.length <= 0"
            :loading="modalState.confirmLoading"
            @click.prevent="fnRecordDelete('0')"
          >
            <template #icon><DeleteOutlined /></template>
            {{ t('common.deleteText') }}
          </a-button>
        </a-space>
      </template>

      <!-- 插槽-卡片右侧 -->
      <template #extra>
        <a-space :size="8" align="center">
          <a-tooltip placement="topRight">
            <template #title>{{ t('common.searchBarText') }}</template>
            <a-switch
              v-model:checked="tableState.seached"
              :checked-children="t('common.switch.show')"
              :un-checked-children="t('common.switch.hide')"
              size="small"
            />
          </a-tooltip>
          <a-tooltip placement="topRight">
            <template #title>{{ t('common.reloadText') }}</template>
            <a-button type="text" @click.prevent="fnGetList()">
              <template #icon><ReloadOutlined /></template>
            </a-button>
          </a-tooltip>
          <a-tooltip placement="topRight">
            <template #title>{{ t('common.sizeText') }}</template>
            <a-dropdown trigger="click" placement="bottomRight">
              <a-button type="text">
                <template #icon><ColumnHeightOutlined /></template>
              </a-button>
              <template #overlay>
                <a-menu
                  :selected-keys="[tableState.size as string]"
                  @click="fnTableSize"
                >
                  <a-menu-item key="default">
                    {{ t('common.size.default') }}
                  </a-menu-item>
                  <a-menu-item key="middle">
                    {{ t('common.size.middle') }}
                  </a-menu-item>
                  <a-menu-item key="small">
                    {{ t('common.size.small') }}
                  </a-menu-item>
                </a-menu>
              </template>
            </a-dropdown>
          </a-tooltip>
        </a-space>
      </template>

      <!-- 表格列表 -->
      <a-table
        class="table"
        row-key="id"
        :columns="tableColumns"
        :loading="tableState.loading"
        :data-source="tableState.data"
        :size="tableState.size"
        :pagination="tablePagination"
        :scroll="{ x: true }"
        @change="fnTableChange"
        :row-selection="{
          type: 'checkbox',
          columnWidth: '48px',
          selectedRowKeys: tableState.selectedRowKeys,
          onChange: fnTableSelectedRowKeys,
        }"
      >
        <template #bodyCell="{ column, record }">
          <template v-if="column.key === 'traceType'">
            <DictTag :options="dict.traceType" :value="record.traceType" />
          </template>
          <template v-if="column.key === 'id'">
            <a-space :size="8" align="center">
              <a-tooltip placement="topRight">
                <template #title>{{ t('common.editText') }}</template>
                <a-button
                  type="link"
                  @click.prevent="fnModalOpenByEdit(record.id)"
                >
                  <template #icon><FormOutlined /></template>
                </a-button>
              </a-tooltip>
              <a-tooltip placement="topRight">
                <template #title>{{
                  t('views.traceManage.task.pcapView')
                }}</template>
                <a-button type="link" @click.prevent="fnRecordPCAPView(record)">
                  <template #icon><ContainerOutlined /></template>
                </a-button>
              </a-tooltip>
              <a-tooltip placement="topRight">
                <template #title>{{ t('common.deleteText') }}</template>
                <a-button
                  type="link"
                  danger
                  @click.prevent="fnRecordDelete(record.id)"
                >
                  <template #icon><DeleteOutlined /></template>
                </a-button>
              </a-tooltip>
            </a-space>
          </template>
        </template>
      </a-table>
    </a-card>

    <!-- 新增框或修改框 -->
    <ProModal
      :drag="true"
      :width="800"
      :destroyOnClose="true"
      :keyboard="false"
      :mask-closable="false"
      :open="modalState.openByEdit"
      :title="modalState.title"
      :confirm-loading="modalState.confirmLoading"
      @ok="fnModalOk"
      @cancel="fnModalCancel"
    >
      <a-form
        name="modalStateFrom"
        layout="horizontal"
        :label-col="{ span: 4 }"
        :label-wrap="true"
      >
        <a-row>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              :label="t('views.ne.common.neType')"
              :label-col="{ span: 8 }"
              name="neType"
              v-bind="modalStateFrom.validateInfos.neId"
            >
              <a-cascader
                v-model:value="modalState.neType"
                :options="neCascaderOptions"
                @change="fnNeChange"
                :allow-clear="false"
                :placeholder="t('views.ne.common.neTypePlease')"
              />
            </a-form-item>
          </a-col>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              :label="t('views.traceManage.task.trackType')"
              :label-col="{ span: 8 }"
              name="traceType"
              v-bind="modalStateFrom.validateInfos.traceType"
            >
              <a-select
                v-model:value="modalState.from.traceType"
                :options="dict.traceType"
                @change="fnTraceTypeChange"
                :allow-clear="false"
                :placeholder="t('views.traceManage.task.trackTypePlease')"
              >
              </a-select>
            </a-form-item>
          </a-col>
        </a-row>

        <a-form-item
          :label="t('views.traceManage.task.rangePicker')"
          name="endTime"
          v-bind="modalStateFrom.validateInfos.endTime"
        >
          <a-range-picker
            v-model:value="modalState.timeRangePicker"
            @change="fnRangePickerChange"
            allow-clear
            bordered
            :show-time="{ format: 'HH:mm:ss' }"
            format="YYYY-MM-DD HH:mm:ss"
            value-format="x"
            style="width: 100%"
            :disabled-date="fnRangePickerDisabledDate"
            :placeholder="[
              t('views.traceManage.task.startTime'),
              t('views.traceManage.task.endTime'),
            ]"
          ></a-range-picker>
        </a-form-item>
        <a-form-item :label="t('views.traceManage.task.remark')" name="remark">
          <a-textarea
            v-model:value="modalState.from.remark"
            :auto-size="{ minRows: 1, maxRows: 6 }"
            :maxlength="450"
            :show-count="true"
            :placeholder="t('views.traceManage.task.remarkPlease')"
          />
        </a-form-item>

        <!-- 接口跟踪 -->
        <template v-if="modalState.from.traceType === '1'">
          <a-form-item
            :label="t('views.traceManage.task.interfaces')"
            name="interfaces"
            v-bind="modalStateFrom.validateInfos.interfaces"
          >
            <a-select
              mode="multiple"
              :placeholder="t('views.traceManage.task.interfacesPlease')"
              v-model:value="modalState.neTypeInterfaceSelect"
              :options="modalState.neTypeInterface"
              @change="fnSelectInterface"
            >
            </a-select>
          </a-form-item>
        </template>

        <!-- 设备跟踪 -->
        <template v-if="modalState.from.traceType === '2'">
          <a-form-item
            :label="t('views.traceManage.task.signalPort')"
            name="signalPort"
            v-bind="modalStateFrom.validateInfos.signalPort"
          >
            <a-input-number
              v-model:value="modalState.from.signalPort"
              style="width: 100%"
              :placeholder="t('views.traceManage.task.signalPortPlease')"
            >
              <template #prefix>
                <a-tooltip placement="topLeft">
                  <template #title>
                    <div>{{ t('views.traceManage.task.signalPortTip') }}</div>
                  </template>
                  <InfoCircleOutlined style="opacity: 0.45; color: inherit;" />
                </a-tooltip>
              </template>
            </a-input-number>
          </a-form-item>
          <a-row>
            <a-col :lg="12" :md="12" :xs="24">
              <a-form-item
                :label="t('views.traceManage.task.srcIp')"
                :label-col="{ span: 8 }"
                name="srcIp"
                v-bind="modalStateFrom.validateInfos.srcIp"
              >
                <a-input
                  v-model:value="modalState.from.srcIp"
                  allow-clear
                  :placeholder="t('views.traceManage.task.srcIpPlease')"
                >
                  <template #prefix>
                    <a-tooltip placement="topLeft">
                      <template #title>
                        <div>{{ t('views.traceManage.task.srcIpTip') }}</div>
                      </template>
                      <InfoCircleOutlined style="opacity: 0.45; color: inherit;" />
                    </a-tooltip>
                  </template>
                </a-input>
              </a-form-item>
            </a-col>
            <a-col :lg="12" :md="12" :xs="24">
              <a-form-item
                :label="t('views.traceManage.task.dstIp')"
                :label-col="{ span: 8 }"
                name="dstIp"
                v-bind="modalStateFrom.validateInfos.dstIp"
              >
                <a-input
                  v-model:value="modalState.from.dstIp"
                  allow-clear
                  :placeholder="t('views.traceManage.task.dstIpPlease')"
                >
                  <template #prefix>
                    <a-tooltip placement="topLeft">
                      <template #title>
                        <div>{{ t('views.traceManage.task.dstIpTip') }}</div>
                      </template>
                      <InfoCircleOutlined style="opacity: 0.45; color: inherit;" />
                    </a-tooltip>
                  </template>
                </a-input>
              </a-form-item>
            </a-col>
          </a-row>
        </template>

        <!-- 用户跟踪 -->
        <template v-if="modalState.from.traceType === '3'">
          <a-form-item
            :label="t('views.traceManage.task.imsi')"
            name="imsi"
            v-bind="modalStateFrom.validateInfos.imsi"
          >
            <a-input
              v-model:value="modalState.from.imsi"
              allow-clear
              :placeholder="t('views.traceManage.task.imsiPlease')"
            >
              <template #prefix>
                <a-tooltip placement="topLeft">
                  <template #title>
                    <div>{{ t('views.traceManage.task.imsiTip') }}</div>
                  </template>
                  <InfoCircleOutlined style="opacity: 0.45; color: inherit;" />
                </a-tooltip>
              </template>
            </a-input>
          </a-form-item>
          <a-form-item
            :label="t('views.traceManage.task.msisdn')"
            name="msisdn"
            v-bind="modalStateFrom.validateInfos.msisdn"
          >
            <a-input
              v-model:value="modalState.from.msisdn"
              allow-clear
              :placeholder="t('views.traceManage.task.msisdnPlease')"
            >
              <template #prefix>
                <a-tooltip placement="topLeft">
                  <template #title>
                    <div>{{ t('views.traceManage.task.msisdnTip') }}</div>
                  </template>
                  <InfoCircleOutlined style="opacity: 0.45; color: inherit;" />
                </a-tooltip>
              </template>
            </a-input>
          </a-form-item>
        </template>
      </a-form>
    </ProModal>
  </PageContainer>
</template>

<style lang="less" scoped>
.table :deep(.ant-pagination) {
  padding: 0 24px;
}
</style>
